#ifndef idBE96C2D49C4C413888A79EAEB2B9C0FA
#define idBE96C2D49C4C413888A79EAEB2B9C0FA

#include <vector>
#include <string>
#include <memory>

namespace duck {
	struct ScrapNode;
	struct element_def;

	class ScrapNodePtr {
	public:
		explicit ScrapNodePtr ( ScrapNode* parPtr );
		ScrapNodePtr ( ScrapNodePtr&& parOther );
		~ScrapNodePtr ( void ) noexcept;

		ScrapNode& operator* ( void ) { return *m_ptr; }
		const ScrapNode& operator* ( void ) const { return *m_ptr; }
		ScrapNode& operator-> ( void ) { return *m_ptr; }
		const ScrapNode& operator-> ( void ) const { return *m_ptr; }

	private:
		std::unique_ptr<ScrapNode> m_ptr;
	};

	ScrapNodePtr parse_scraplang ( const std::string& parData );
	std::vector<element_def> get_xpath_definitions ( const ScrapNode& parAST );
} //namespace duck

#endif
